#include <stdio.h>
#include <windows.h>

void mainsub(void) { printf("hello from main sub\n"); }

void load_and_call_sub(void)
{
  HINSTANCE handle;
  void (*f)(void) = 0;

  printf("hello from dynmain\n");
  handle = LoadLibrary("dynsub.dll");
  if (handle == NULL)
    {
      DWORD lastError = GetLastError ();
      char *msg;
      
      switch (lastError)
	{
	case ERROR_MOD_NOT_FOUND:
	case ERROR_DLL_NOT_FOUND:
	  msg = "could not find library or dependents";
	  break;
	  
	case ERROR_INVALID_DLL:
	  msg = "library or its dependents are damaged";
	  break;
	  
	case ERROR_DLL_INIT_FAILED:
	  msg = "library initialization routine failed";
	  break;
	  
	case ERROR_BAD_EXE_FORMAT:
	  msg = "bad exe format";
	  break;

	default:
	  printf("library open failed with %d\n",lastError);
	  return;
	}
      printf("%s\n",msg);
      return;
    }

  f = GetProcAddress (handle, "dynsub");
  if (f) 
    {
      printf("calling dynsub\n");
      (*f)();
      printf("returning to dynmain\n");
    }
  else printf("could not load dynsub\n");

  return;
}
